
/* This is the client stub module for Maelstrom Sound */

#include "sound_cmds.h"

#define SYNC_SOUND	0
#define ASYNC_SOUND	1

class SoundClient {

public:
	SoundClient(int asynchronous);
	~SoundClient();

	void SoundEvent(void);			/* Sound Event handler */
	int  QueryServer(void);
	int  SetVolume(unsigned short vol);
	int  LoadSound(short sndID);
	int  PlaySound(short sndID, short priority, 
					void (*STCallBack)(unsigned short));
	int  PlayChannel(short sndID, short priority,
		unsigned short theChannel, void (*STCallBack)(unsigned short));
	void HaltSounds(void);
	void HaltChannel(unsigned short theChannel);
	int  IsSoundPlaying(short sndID);
	void ChannelStatus(unsigned short *chanOnePriority, 
			   unsigned short *chanTwoPriority, 
			   unsigned short *chanThreePriority, 
			   unsigned short *chanFourPriority);

private:
	int  GetReply(int timeout);		/* Wait for OKAY_CMD */
	int  GetIntReply(void);			/* Wait for status return */
	int  SendCmdBuf(char *cmdbuf);		/* Send a command to server */
	int  SoundID(unsigned short channel);
	int  Status(unsigned short channel);
	void CallBack(unsigned short channel);

	int channel_fd;
	int sndserver_pid;
	int server_events;
	int server_reply;
	int run_async;				/* ASYNC I/O flag */

	struct channel {
		int    in_use;
		short  ID;
		short  priority;
		void (*Callback)(unsigned short);
		} channels[NUM_CHANNELS];
};
